﻿@page "/constructDocuments"
@using SPAWebApp.Shared
@using SPAWebApp.Shared.Models
@using SPAWebApp.Client.Services.Contracts
@using SPAWebApp.Client.Pages.ConstructDocument.Components
@using SPAWebApp.Shared.Models.Services.ConstructDocument
@inject IConstructDocumentService ConstructDocumentService
<!--todo: вынести Conrols и Search в отдельные компоненты-->
<!--todo: вынести блок functions в ViewModel-->
<!--todo: удалить блок TEST-->
<!-- Documents Section -->
<section class="content-files">

  @switch (state)
  {
    case State.List:
      <!-- Controls -->
      <div class="top-menu">
        <button class="btn btn-info" title="Добавить" onclick="@( () =>  ChangeStateToAdd())"><i class="fas fa-plus"></i></button>
        <button class="btn btn-info" title="Экспорт"><i class="fas fa-file-excel"></i></button>
      </div>
      <!-- End Controls -->
      <!-- Search -->
      <div class="block-search">
        <input type="search" name="search">
        <button type="button" class="btn btn-primary btn-sm btn-search"><i class="fas fa-search"></i></button>
      </div>
      <!-- End Search -->
      <!-- Documents List -->
      <div id="table">
        <ConstructDocumentsList Documents="@Documents"
                                SelectedDocument="@SelectDocument" />
      </div>
      <div>
        <button onclick="@(async () => await PreviousPage())">Prev</button>
        <button>@CurrentPage</button>
        <button onclick="@(async () => await NextPage())">Next</button>
      </div>
      <!-- End Documents List -->
      break;

    case State.Document:
      <button class="btn btn-info" title="Назад" onclick="@(async () => await ClearObject())"><i class="fas fa-arrow-circle-left"></i> </button>
      <ConstructDocumentsInfo Document="@SelectedDocument"
                              DocumentDeleted="@(async () => await ClearObject())" />
      break;
    case State.Add:
      <button class="btn btn-info" title="Назад" onclick="@(async () => await ClearObject())"><i class="fas fa-arrow-circle-left"></i> </button>
      <ConstructDocumentAddNewDocumentForm 
        DocumentAddedGetIdAsync="@(async (string id) => await ChangeStateToList(id))" />
      break;
  }
</section>
<!-- End Documents Section -->

@functions {
  protected List<Document> Documents;
  protected Document SelectedDocument;

  enum State { List, Document, Add }

  State state;

  public int PagesCount { get; set; } = 0;

  public int CurrentPage { get; set; } = 0;

  protected override async Task OnInitAsync()
  {
    Console.WriteLine($"{nameof(ConstructDocuments)}.{nameof(OnInitAsync)}");

    var result = await ConstructDocumentService.GetDocumentsOfFirstPageAsync();
    Documents = result.Documents;
    CurrentPage = 0;
    PagesCount = result.Pages;

    StateHasChanged();

    Console.WriteLine($"{nameof(ConstructDocuments)}.{nameof(OnInitAsync)}: done");
  }

  protected async Task NextPage()
  {
    Documents = await ConstructDocumentService.GetDocumentsOfPageAsync(CurrentPage++);
  }

  protected async Task PreviousPage()
  {
    Documents = await ConstructDocumentService.GetDocumentsOfPageAsync(CurrentPage--);
  }
  protected void SelectDocument(Document document)
  {
    SelectedDocument = new Document()
    {
      Id = document.Id,
      Revision = document.Revision,
      State = document.State,
      Name = document.Name,
      Designation = document.Designation
    };
    state = State.Document;
    StateHasChanged();
  }

  protected async Task RefreshTable()
  {
    Documents = await ConstructDocumentService.GetAllDataAsync();
  }

  protected async Task ClearObject()
  {
    state = State.List;
    await RefreshTable();
    StateHasChanged();
  }

  protected void ChangeStateToAdd()
  {
    state = State.Add;
    StateHasChanged();
  }

  protected async Task ChangeStateToList(string id)
  {
    Console.WriteLine("Пришел сюда");
    state = State.List;
    Console.WriteLine(id);
    try
    {
      var test = new Document();
      try
      {
        test = await ConstructDocumentService.GetDataAsync(id);
      }
      catch(Exception e) {Console.WriteLine(e.Message); }
      
      Console.WriteLine("Document is receive");
      Documents.Add(test);
      StateHasChanged();
    }catch(Exception e)
    {
      Console.WriteLine(e.Message);
    }
  }
}
